﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using PAT.Common.Classes.CUDDLib;
using System.Collections;

namespace Analysis_Part
{
    [Serializable]
    class LatticeBasedOnBDD
    {
        public static bool[] upgradeFeature;
        public CUDDNode value;
        static CUDDVars vars;
        // name and index mapping, init. in variable-index
        static Dictionary<String, int> dic = new Dictionary<String, int>();

        private static int variableIndex(String s)
        {
            if (dic.ContainsKey(s)) return dic[s];
            if (upgradeFeature == null) upgradeFeature = new bool[1];
            else
            {
                if (upgradeFeature.Count() <= vars.GetNumVars())
                {
                    bool[] newUpgradeFeature = new bool[upgradeFeature.Count() + 1];
                    for (int i = 0; i < upgradeFeature.Count(); ++i) newUpgradeFeature[i] = upgradeFeature[i];
                    newUpgradeFeature[upgradeFeature.Count()] = false;
                    upgradeFeature = newUpgradeFeature;
                }
            }
            /*int result = dic.Keys.Count;
            Console.WriteLine(result);
            dic.Add(s, result);
            return result;*/
            int result = vars.GetNumVars();
            Console.WriteLine(result);
            vars.AddVar(CUDD.Var(result));
            dic.Add(s, result);
            Console.WriteLine("Current dic: ");
            foreach (string st in dic.Keys) Console.WriteLine(st);
            return result;
        }

        public LatticeBasedOnBDD() { }

        public static bool initialiseVariables(string variables){
            String variables2=variables.Replace(" ", "");
            String[] vars = variables2.Split(',');
            initialised = true;
            CUDD.InitialiseCUDD(256, 256, 262144, 0.1);
            LatticeBasedOnBDD.vars = new CUDDVars();
            foreach (String var in vars)
            {
                if (var.ToLower().Equals("-") ||var.ToLower().Equals("and") || var.ToLower().Equals("or") || var.ToLower().Equals("not") || var.ToLower().Equals("true") || var.ToLower().Equals("false") ||var.Contains("(")||var.Contains(")")) return false;
                variableIndex(var);
            }
            return true;
        }
        public static bool initialiseUpgradeFeatures(string upgradeFeatures)
        {
            try
            {
                upgradeFeature = new bool[dic.Count()];
                //Update allow "" for features
                if (upgradeFeatures == "") return true;

                String variables2 = upgradeFeatures.Replace(" ", "");
                String[] vars = variables2.Split(',');
                foreach (String var in vars)
                {
                    if (!dic.ContainsKey(var)) return false;
                    upgradeFeature[variableIndex(var)] = true;
                }


            }catch
            {

            }
            return true;
        }

        public LatticeBasedOnBDD(String logicformula)
        {
            logicformula = logicformula.Replace("(", " ( ");
            logicformula = logicformula.Replace(")", " ) ");
            logicformula = logicformula.ToLower();
            Console.WriteLine(logicformula);
            while (logicformula.Contains("  ")) logicformula = logicformula.Replace("  ", " ");
            Console.WriteLine(logicformula);
            String[] sequence = logicformula.Split(new Char[] { ' ' });
            List<String> stack = new List<String>();
            List<CUDDNode> booleanExpressions = new List<CUDDNode>();
            for (int i = 0; i < sequence.Count(); ++i)
            {
                Console.WriteLine("stack content at iteration " + i + ": ");
                foreach (String stacky in stack) Console.WriteLine(stacky);
                Console.WriteLine("booleanExpressions at iteration " + i + ": ");
                foreach (CUDDNode stacky in booleanExpressions) CUDD.Print.PrintVector(stacky, vars);
                if (sequence[i].Length == 0) continue;
                if (sequence[i].ToLower().Equals("true"))
                {
                    if (stack.Count == 0)
                    {
                        stack.Insert(0, "(");
                        continue;
                    }
                    if (stack[0].Equals("or") || stack[0].Equals("and") || stack[0].Equals("not") || stack[0].Equals("("))
                    {
                        stack.Insert(0, "(");
                        continue;
                    }
                    Console.WriteLine("Error in formating the logic formula " + logicformula + ": ( following neither and, nor or, nor not, nor (");
                    return;
                }
                if (sequence[i].Equals("("))
                {
                    if (stack.Count == 0)
                    {
                        stack.Insert(0, "(");
                        continue;
                    }
                    if (stack[0].Equals("or") || stack[0].Equals("and") || stack[0].Equals("not") || stack[0].Equals("("))
                    {
                        stack.Insert(0, "(");
                        continue;
                    }
                    Console.WriteLine("Error in formating the logic formula " + logicformula + ": ( following neither and, nor or, nor not, nor (");
                    return;
                }
                if (sequence[i].ToLower().Equals("not"))
                {
                    if ((stack.Count == 0) || stack[0].Equals("and") || stack[0].Equals("or") || stack[0].Equals("("))
                    {
                        stack.Insert(0, "not");
                        continue;
                    }
                    if (stack[0].Equals("not"))
                    {
                        stack.RemoveAt(0);
                        continue;
                    }
                    Console.WriteLine("Error in formating the logic formula " + logicformula + ": not following neither and, nor or, nor not, nor (");
                    return;
                }
                if (sequence[i].ToLower().Equals("and"))
                {
                    if (stack.Count == 0)
                    {
                        Console.WriteLine("Error in formating the logic formula " + logicformula + ": and as the first symbol");
                        return;
                    }
                    if (stack[0].Equals("and") || stack[0].Equals("or") || stack[0].Equals("(") || stack[0].Equals("not"))
                    {
                        Console.WriteLine("Error in formating the logic formula " + logicformula + ": and following " + stack[0]);
                        return;
                    }
                    stack.Insert(0, "and");
                    continue;
                }
                if (sequence[i].ToLower().Equals("or"))
                {
                    if (stack.Count == 0)
                    {
                        Console.WriteLine("Error in formating the logic formula " + logicformula + ": and as the first symbol");
                        return;
                    }
                    if (stack[0].Equals("and") || stack[0].Equals("or") || stack[0].Equals("(") || stack[0].Equals("not"))
                    {
                        Console.WriteLine("Error in formating the logic formula " + logicformula + ": or following " + stack[0]);
                        return;
                    }
                    if ((stack.Count == 1) || stack[1].Equals("("))
                    {
                        stack.Insert(0, "or");
                        continue;
                    }
                    stack.RemoveAt(0);
                    CUDDNode intermediate = CUDD.Function.Or(booleanExpressions[0], booleanExpressions[1]);
                    booleanExpressions.RemoveAt(0);
                    booleanExpressions.RemoveAt(0);
                    booleanExpressions.Add(intermediate);
                    continue;
                }
                if (sequence[i].Equals(")"))
                {
                    if (stack.Count <= 1)
                    {
                        Console.WriteLine("Error in formating the logic formula " + logicformula + ": ) as the " + ((stack.Count == 0) ? "first" : "second") + " symbol");
                        return;
                    }
                    if (stack[0].Equals("and") || stack[0].Equals("or") || stack[0].Equals("(") || stack[0].Equals("not"))
                    {
                        Console.WriteLine("Error in formating the logic formula " + logicformula + ": ) following " + stack[0]);
                        return;
                    }
                    while (!stack[1].Equals("("))
                    {
                        if (stack[1].Equals("or"))
                        {
                            stack.RemoveAt(0);
                            stack.RemoveAt(0);
                            CUDDNode intermediate = CUDD.Function.Or(booleanExpressions[0], booleanExpressions[1]);
                            booleanExpressions.RemoveAt(0);
                            booleanExpressions.RemoveAt(0);
                            booleanExpressions.Add(intermediate);
                        }
                    }
                    if (stack[1].Equals("("))
                    {
                        stack.RemoveAt(1);
                        if ((stack.Count > 1) && (stack[1].Equals("not")))
                        {
                            CUDDNode intermediate = CUDD.Function.Not(booleanExpressions[0]);
                            booleanExpressions.RemoveAt(0);
                            booleanExpressions.Insert(0, intermediate);
                            stack.RemoveAt(1);
                        }
                    }
                    if (stack.Count > 1)
                    {
                        if (stack[1].Equals("and"))
                        {
                            stack.RemoveAt(0);
                            stack.RemoveAt(0);
                            CUDDNode intermediate = CUDD.Function.And(booleanExpressions[0], booleanExpressions[1]);
                            booleanExpressions.RemoveAt(0);
                            booleanExpressions.RemoveAt(0);
                            booleanExpressions.Add(intermediate);
                        }
                    }
                    continue;
                }
                CUDDNode newVar = CUDD.Var(variableIndex(sequence[i]));
                CUDD.Ref(newVar);
                if ((stack.Count > 0) && stack[0].Equals("not"))
                {
                    Console.WriteLine("Not found, now compare newVar before and after negation: ");
                    stack.RemoveAt(0);
                    CUDD.Print.PrintVector(newVar, vars);
                    newVar = CUDD.Function.Not(newVar);
                    CUDD.Print.PrintVector(newVar, vars);

                }
                if ((stack.Count == 0) || stack[0].Equals("(") || stack[0].Equals("or"))
                {
                    booleanExpressions.Insert(0, newVar);
                    stack.Insert(0, sequence[i]);
                    continue;
                }
                if (stack[0].Equals("and"))
                {
                    stack.RemoveAt(0);
                    CUDDNode intermediate = CUDD.Function.And(booleanExpressions[0], newVar);
                    booleanExpressions.RemoveAt(0);
                    booleanExpressions.Insert(0, intermediate);
                    continue;
                }
                if (stack[0].Equals("or"))
                {
                    if ((stack.Count > 3) && (stack[2].Equals("or")))
                    {
                        CUDDNode intermediate = CUDD.Function.Or(booleanExpressions[0], booleanExpressions[1]);
                        booleanExpressions.RemoveAt(0);
                        booleanExpressions.RemoveAt(0);
                        booleanExpressions.Insert(0, intermediate);
                        stack.RemoveAt(1);
                        stack.RemoveAt(1);
                    }
                    stack.Insert(0, sequence[i]);
                    booleanExpressions.Insert(0, CUDD.Var(variableIndex(sequence[i])));
                    continue;
                }
                Console.WriteLine("Error in formating the logic formula " + logicformula + ": Variable " + sequence[i] + " following a variable");
                return;

            }
            Console.WriteLine("stack content after all iterations: ");
            foreach (String stacky in stack) Console.WriteLine(stacky);
            Console.WriteLine("booleanExpressions after all iterations: ");
            foreach (CUDDNode stacky in booleanExpressions) CUDD.Print.PrintVector(stacky, vars);
            while (stack.Count > 1)
            {
                Console.WriteLine("CleanUp " + stack.Count);
                if (stack[1].Equals("and"))
                {
                    CUDDNode intermediate = CUDD.Function.And(booleanExpressions[0], booleanExpressions[1]);
                    booleanExpressions.RemoveAt(0);
                    booleanExpressions.RemoveAt(0);
                    booleanExpressions.Insert(0, intermediate);
                    stack.RemoveAt(1);
                    stack.RemoveAt(1);
                    continue;
                }
                if (stack[1].Equals("or"))
                {
                    CUDDNode intermediate = CUDD.Function.Or(booleanExpressions[0], booleanExpressions[1]);
                    booleanExpressions.RemoveAt(0);
                    booleanExpressions.RemoveAt(0);
                    booleanExpressions.Insert(0, intermediate);
                    stack.RemoveAt(1);
                    stack.RemoveAt(1);
                    continue;
                }
            }
            this.value = booleanExpressions[0];
        }

        public LatticeBasedOnBDD(CUDDNode value)
        {
            this.value = value;
        }
        public LatticeBasedOnBDD(CUDDVars vars, CUDDNode value)
        {
            LatticeBasedOnBDD.vars = vars;
            this.value = value;
        }
        static bool initialised = false;
        public static void initialise(int numberOfVariables)
        {
            initialised = true;
            Console.WriteLine("Initialized");
            CUDD.InitialiseCUDD(256, 256, 262144, 0.1);
            vars = new CUDDVars();
            for (int i = 0; i < numberOfVariables; ++i)
                vars.AddVar(CUDD.Var(i));
            upgradeFeature = new bool[numberOfVariables];
        }
        public static void initialise(int numberOfVariables, bool[] upgradeFeatures)
        {
            initialise(numberOfVariables);
            upgradeFeature = upgradeFeatures;
        }

        public static CUDDNode approximate(CUDDNode a)
        {
            CUDD.Ref(a);
            //Console.WriteLine("Approximating ");CUDD.Print.PrintVector(a, vars);
            if (a.IsConstant()) return a;
            CUDDNode result;
            CUDDNode leftapprox = approximate(a.GetThen());
            CUDDNode rightapprox = approximate(a.GetElse());
            //CUDD.Ref(leftapprox);
            //CUDD.Ref(leftapprox);
            //CUDD.Ref(rightapprox);
            //Console.WriteLine("Approximated ");
            //CUDD.Print.PrintVector(a, vars);
            //Console.WriteLine("using "+(leftapprox.IsConstant()?"constant ":"")+ "THEN: ");
            //CUDD.Print.PrintVector(leftapprox, vars);

            //Console.WriteLine("and " + (rightapprox.IsConstant() ? "constant " : "") + "ELSE: ");
            //CUDD.Print.PrintVector(rightapprox, vars);
            //Console.WriteLine("obtaining: ");

            //CUDD.Print.PrintVector(CUDD.Function.ITE(CUDD.Var(a.GetIndex()), leftapprox, CUDD.Function.And(leftapprox, rightapprox)), vars);
            //CUDD.Deref(leftapprox);
            //CUDD.Deref(rightapprox);
            if (upgradeFeature[a.GetIndex()])
                result = CUDD.Function.ITE(CUDD.Var(a.GetIndex()), leftapprox, CUDD.Function.And(leftapprox, rightapprox));
            else
                result = CUDD.Function.ITE(CUDD.Var(a.GetIndex()), leftapprox, rightapprox);
            return result;
        }


        public static CUDDNode closeDown(CUDDNode a)
        {
            CUDD.Ref(a);
            if (a.IsConstant()) return a;
            CUDDNode result;
            CUDDNode leftapprox = closeDown(a.GetThen());
            CUDDNode rightapprox = closeDown(a.GetElse());

            result = CUDD.Function.ITE(CUDD.Var(a.GetIndex()), leftapprox, CUDD.Function.Or(leftapprox, rightapprox));
            return result;
        }

        public static LatticeBasedOnBDD operator +(LatticeBasedOnBDD a, LatticeBasedOnBDD b)
        {
            CUDD.Ref(a.value);
            CUDD.Ref(b.value);
            return new LatticeBasedOnBDD(CUDD.Function.Or(a.value, b.value));
        }

        public static LatticeBasedOnBDD operator *(LatticeBasedOnBDD a, LatticeBasedOnBDD b)
        {
            CUDD.Ref(a.value);
            CUDD.Ref(b.value);
            return new LatticeBasedOnBDD(CUDD.Function.And(a.value, b.value));
        }

        public static LatticeBasedOnBDD operator /(LatticeBasedOnBDD a, LatticeBasedOnBDD b)
        {
            CUDD.Ref(a.value);
            CUDD.Ref(b.value);
            return new LatticeBasedOnBDD(approximate(CUDD.Function.Implies(b.value, a.value)));
        }

        public static bool operator ==(LatticeBasedOnBDD a, LatticeBasedOnBDD b)
        {
            CUDD.Ref(a.value);
            CUDD.Ref(b.value);
            return a.value == b.value;
        }

        public static bool operator !=(LatticeBasedOnBDD a, LatticeBasedOnBDD b)
        {
            return !(a == b);
        }

        public static LatticeBasedOnBDD Zero()
        {
            CUDDNode zero = CUDD.Function.Not(CUDD.ONE);
            CUDD.Ref(zero);
            return new LatticeBasedOnBDD(zero);
        }

        public static LatticeBasedOnBDD One()
        {
            if (!initialised) initialise(5);
            CUDDNode one = CUDD.ONE;
            CUDD.Ref(one);
            return new LatticeBasedOnBDD(one);
        }

        public static bool operator >=(LatticeBasedOnBDD a, LatticeBasedOnBDD b)
        {
            return a * b == b;
        }

        public static bool operator <=(LatticeBasedOnBDD a, LatticeBasedOnBDD b)
        {
            return a * b == a;
        }

        public void print()
        {
            CUDD.Print.PrintVector(value, vars);
        }

        public String BDDToString(CUDDNode value){
            if (value.Equals(CUDD.ONE)) return "1";
            if (value.Equals(CUDD.Function.Not(CUDD.ONE))) return "0";
            if(value.IsConstant()){
                foreach(String key in dic.Keys)if(value.GetIndex()==dic[key]) return key;
                return "";
            }
            string result = "if ";
            foreach (String key in dic.Keys) if (value.GetIndex() == dic[key]) result += key;
            result += " then (" + BDDToString(value.GetThen()) + ") else (" + BDDToString(value.GetElse()) + ")";
            
            return result;
        }
        public override string ToString()
        {
            //print();
            return BDDToString(value);
            //return getFiniteLattice().ToString();
        }

        public static Preorder getPreorderForVariableNumber(int n)
        {
            Preorder result = new Preorder((int)Math.Pow(2, n));
            for (int index = 0; index < (int)Math.Pow(2, n); ++index)
                for (int i = 0; i < n; ++i)
                    if ((index & (int)Math.Pow(2, i)) == 0)
                        result.addOrderPair(index, index + (int)Math.Pow(2, i));
            return result;
        }

        private bool evaluate(int i)
        {
            CUDDNode currentNode = value;
            while (!currentNode.IsConstant())
                if (((int)Math.Pow(2, currentNode.GetIndex()) & i) != 0)
                    currentNode = currentNode.GetThen();
                else currentNode = currentNode.GetElse();
            if (currentNode == CUDD.ZERO) return false;
            return true;
        }

        public FiniteLattice getFiniteLattice()
        {
            BitArray downset = new BitArray((int)Math.Pow(2, vars.GetNumVars()));
            for (int i = 0; i < (int)Math.Pow(2, vars.GetNumVars()); ++i)
                if (evaluate(i)) downset[i] = true;
            return new FiniteLattice(downset, getPreorderForVariableNumber(vars.GetNumVars()));
        }

        /// <summary>
        /// Check whether a linear combination exists, using the the algorithm from Zhou / Li: Largest Solution of Linear Equation over the complete heyting algebra.
        /// </summary>
        /// <param name="set">The set of rows the vector shall be combined from.</param>
        /// <param name="vec">The vector (represented as an array) that may be combined linearly.</param>
        /// <returns>A LinearCombination object that indicates in the field CombinationExists, whether a linear combination was found, and, provided a combination was found, in its field Multiplicands the multiplicands that form the linear combination.</returns>
        public static LinearCombination<LatticeBasedOnBDD> LinearCombination(List<LatticeBasedOnBDD[]> set, LatticeBasedOnBDD[] vec)
        {

            LinearCombination<LatticeBasedOnBDD> lc;
            lc.CombinationExists = true;
            lc.Multiplicands = new LatticeBasedOnBDD[set.Count()];
            for (int j = 0; j < lc.Multiplicands.Length; ++j)
            {
                lc.Multiplicands[j] = One();
                for (int i = 0; i < vec.Length; ++i)
                {
                    //i\in M_j(A,b)?
                    if (!(set[j][i] <= vec[i]))
                        lc.Multiplicands[j] *= vec[i] / set[j][i];
                }
            }
            //Check, if linear combination was found:
            for (int i = 0; i < vec.Length; ++i)
            {
                if (vec[i] != Matrix<LatticeBasedOnBDD>.multiplyVectors(Matrix<LatticeBasedOnBDD>.getColumn(set, i), lc.Multiplicands)) lc.CombinationExists = false;
            }
            return lc;
        }


        public static void Test1()
        {
            CUDDNode a, b, c;

            Console.WriteLine("\nTest program for CUDD\n====================");

            // initialise cudd
            initialise(3);

            //        // blank dd
            c = CUDD.Function.And(CUDD.Function.And(CUDD.Function.Not(CUDD.Var(0)), CUDD.Var(1)), CUDD.Var(2));
            Console.WriteLine("c: ");
            CUDD.Print.PrintVector(c, vars);
            CUDD.Print.PrintVector(approximate(c), vars);
            CUDD.Print.PrintVector(c, vars);
            CUDD.Print.PrintVector(closeDown(c), vars);
            CUDD.Print.PrintVector(approximate(closeDown(c)), vars);
            CUDD.Deref(c);

            b = CUDD.Function.And(CUDD.Function.And(CUDD.Function.Not(CUDD.Var(0)), CUDD.Function.Not(CUDD.Var(1))), CUDD.Function.Not(CUDD.Var(2)));
            Console.WriteLine("b: ");
            CUDD.Print.PrintVector(b, vars);
            CUDD.Print.PrintVector(approximate(b), vars);
            CUDD.Print.PrintVector(closeDown(b), vars);
            CUDD.Print.PrintVector(approximate(closeDown(b)), vars);
            CUDD.Deref(b);


            //        // constant
            a = CUDD.Constant(1.5);
            Console.WriteLine("\nConstant(1.5)");
            CUDD.Print.PrintVector(a, vars);
            CUDD.Deref(a);

            // var
            a = CUDD.Var(0);
            Console.WriteLine("\nVar(0)");
            CUDD.Print.PrintVector(a, vars);
            CUDD.Deref(a);

            a = CUDD.Var(0);
            b = CUDD.Var(2);
            Console.Write("\na: ");
            CUDD.Print.PrintVector(a, vars);
            Console.Write("b: ");
            CUDD.Print.PrintVector(b, vars);

            // not
            CUDD.Ref(a);
            c = CUDD.Function.Not(a);
            Console.WriteLine("\nNot(a)");
            CUDD.Print.PrintVector(c, vars);
            CUDD.Deref(c);

            //        // or
            CUDD.Ref(a);
            CUDD.Ref(b);
            c = CUDD.Function.Or(a, b);
            Console.WriteLine("\nOr(a, b)");
            CUDD.Print.PrintVector(c, vars);
            CUDD.Deref(c);

            // and
            CUDD.Ref(a);
            CUDD.Ref(b);
            c = CUDD.Function.And(a, b);
            Console.WriteLine("\nAnd(a, b)");
            CUDD.Print.PrintVector(c, vars);
            CUDD.Deref(c);

            //        // xor
            CUDD.Ref(a);
            CUDD.Ref(b);
            c = CUDD.Function.Xor(a, b);
            Console.WriteLine("\nXor(a, b)");
            CUDD.Print.PrintVector(c, vars);
            CUDDNode d = approximate(c);
            CUDD.Print.PrintVector(d, vars);
            CUDD.Deref(c);

            // implies
            CUDD.Ref(a);
            CUDD.Ref(b);
            c = CUDD.Function.Implies(CUDD.Function.Not(CUDD.Var(1)), CUDD.Function.Not(CUDD.Var(2)));
            Console.WriteLine("\nImplies(a, b)");
            CUDD.Print.PrintVector(c, vars);
            d = approximate(c);
            CUDD.Print.PrintVector(d, vars);
            CUDD.Deref(c);
            Console.ReadLine();

            CUDD.Deref(a);
            CUDD.Deref(b);

            a = CUDD.Create();
            a = CUDD.Matrix.SetVectorElement(a, vars, 0, 1);
            a = CUDD.Matrix.SetVectorElement(a, vars, 1, 2);
            a = CUDD.Matrix.SetVectorElement(a, vars, 2, 3);
            a = CUDD.Matrix.SetVectorElement(a, vars, 3, 4);
            b = CUDD.Create();
            b = CUDD.Matrix.SetVectorElement(b, vars, 0, 0);
            b = CUDD.Matrix.SetVectorElement(b, vars, 1, 2);
            b = CUDD.Matrix.SetVectorElement(b, vars, 2, 4);
            b = CUDD.Matrix.SetVectorElement(b, vars, 3, 6);
            Console.Write("\na: ");
            CUDD.Print.PrintVector(a, vars);
            Console.Write("b: ");
            CUDD.Print.PrintVector(b, vars);

            //        // apply


            CUDD.Deref(a);
            CUDD.Deref(b);

            // dereference variables
            vars.Deref();


            // close down cudd
            CUDD.CloseDownCUDD();
            Console.WriteLine();
        }
    }
}
