﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Analysis_Part
{
    /// <summary>
    /// A structure to represent the multiplicands for a linear combination as well as a boolean taht indicates if a linear combination indeed exists.
    /// </summary>
    /// <typeparam name="T">The type of the multiplicands.</typeparam>
    public struct LinearCombination<T>
    {
        /// <summary>
        /// A boolean that indicates if a linear combination was found.
        /// </summary>
        public bool CombinationExists;
        /// <summary>
        /// A T-valued array that stores the multiplicands.
        /// </summary>
        public T[] Multiplicands;

        public override string ToString()
        {
            if (!CombinationExists) return "There does not exist a linear combination";
            String result="There is a linear combination, the multiplicands are: ";
            for (int i = 0; i < Multiplicands.Length; ++i) result += Multiplicands[i].ToString() + ((i < Multiplicands.Length) ? "; " : "");
            return result;
        }

    }
}
