﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Analysis_Part
{
    [Serializable]
    public class TemplateForFields: Semiring
    {

        /* Define Copy Constructor for Field-elements:*/
        public TemplateForFields(TemplateForFields x)
        {
            
        }

        /* Standard-Konstruktor, nicht zwingend erforderlich */
        public TemplateForFields() {}

        /* Define the necessary operators:*/
        public static TemplateForFields operator +(TemplateForFields c1, TemplateForFields c2)
        {
            return new TemplateForFields();
        }
        public static TemplateForFields operator *(TemplateForFields c1, TemplateForFields c2)
        {
            return new TemplateForFields();
        }
        public static TemplateForFields operator -(TemplateForFields c1, TemplateForFields c2)
        {
            return new TemplateForFields();
        }

        public static TemplateForFields operator ++(TemplateForFields x)
        {
            return new TemplateForFields();
        }
        public static TemplateForFields operator -(TemplateForFields x)
        {
            return new TemplateForFields();
        }
        public static TemplateForFields operator /(TemplateForFields c1, TemplateForFields c2)
        {
            return new TemplateForFields();
        }
        public static bool operator !=(TemplateForFields c1, TemplateForFields c2)
        {
            return false;
        }
        public static bool operator ==(TemplateForFields c1, TemplateForFields c2)
        {
            return true;
        }


        /* Define how Field-elements should be printed, as well as the one- and the zero-element of the Field:*/
        public override string ToString()
        {
            return "";
        }
        public static TemplateForFields One()
        {
            return new TemplateForFields();
        }
        public static TemplateForFields Zero()
        {
            return new TemplateForFields();
        }

        /* Naive implementation of Gaußian elimination. Replace this method's body if
         you want to implement another algorithm for finding linear combinations. 
         Otherwise, leave intact. */
        public static LinearCombination<TemplateForFields> LinearCombination(List<TemplateForFields[]> set, TemplateForFields[] vec)
        {
            List<TemplateForFields[]> setT = Transpose(DeepRowListCopy(set));
            Permutation p = new Permutation();
            TemplateForFields[] vecCopy = DeepArrayCopy(vec);
            DownwardElimination(setT, vecCopy, p);
            LinearCombination<TemplateForFields> lc = UpwardElimination(setT, vecCopy);
            p.ApplyTo<TemplateForFields>(lc.Multiplicands);

            return lc;
        }

        
        /* From here on out, all functions can remain unchanged, except for the obvious
         * necessity to exchange all "TemplateForFields" with the name of your field*/
        public static TemplateForFields[] CopyArray(TemplateForFields[] a)
        {
            TemplateForFields[] result = new TemplateForFields[a.Length];
            for (int i = 0; i < a.Length; ++i) result[i] = new TemplateForFields(a[i]);
            return result;
        }

        public static List<TemplateForFields[]> DeepRowListCopy(List<TemplateForFields[]> set)
        {
            List<TemplateForFields[]> result = new List<TemplateForFields[]>();
            for (int i = 0; i < set.Count(); ++i)
            {
                TemplateForFields[] row = new TemplateForFields[set[i].Length];
                for (int j = 0; j < set[i].Length; ++j)
                {
                    row[j] = new TemplateForFields(set[i][j]);
                }
                result.Add(row);
            }
            return result;
        }

        public static TemplateForFields[] DeepArrayCopy(TemplateForFields[] x)
        {
            TemplateForFields[] result = new TemplateForFields[x.Length];
            for (int i = 0; i < x.Length; ++i) result[i] = new TemplateForFields(x[i]);
            return result;
        }

        public static TemplateForFields[] MultiplyCopyArray(TemplateForFields[] a, TemplateForFields b)
        {
            TemplateForFields[] result = CopyArray(a);
            MultiplyArray(result, b);
            return result;
        }
        public static void SubtractArray(TemplateForFields[] a, TemplateForFields[] b)
        {
            for (int i = 0; i < a.Length; ++i) a[i] = a[i] - b[i];
        }
        public static void AddArray(TemplateForFields[] a, TemplateForFields[] b)
        {
            for (int i = 0; i < a.Length; ++i) a[i] = a[i] + b[i];
        }
        public static void SubtractArray(TemplateForFields[] a, TemplateForFields b)
        {
            for (int i = 0; i < a.Length; ++i) a[i] = a[i] - b;
        }
        public static void AddArray(TemplateForFields[] a, TemplateForFields b)
        {
            for (int i = 0; i < a.Length; ++i) a[i] = a[i] + b;
        }
        
        public static void swapArrayIndex(TemplateForFields[] a, int i, int j)
        {
            swapArrayIndex<TemplateForFields>(a,i,j);
        }
        public static void swapListIndex(List<TemplateForFields> l, int i, int j)
        {
            swapListIndex<TemplateForFields>(l, i, j);
        }

        public static void swapArrayIndexInList(List<TemplateForFields[]> l, int i, int j)
        {
            swapArrayIndexInList<TemplateForFields>(l, i, j);
        }

        public static void DownwardElimination(List<TemplateForFields[]> set, TemplateForFields[] vec, Permutation p)
        {
            if (set.Count() == 0) return;
            for (int i = 0; i< set[0].Length; ++i)
            {
                
                //Console.WriteLine("i: " + i.ToString() + ", vec.Length: " + vec.Length.ToString() + ", set[i].Length: " + set[i].Length.ToString());
                if (set[i][i] != Zero())
                {
                    vec[i] /= set[i][i];
                    DivideArray(set[i], set[i][i]);
                    for (int j = i+1; j < set.Count(); ++j)
                    {
                        vec[j] -= vec[i] * set[j][i];
                        SubtractArray(set[j], MultiplyCopyArray(set[i], set[j][i]));
                    }
                }
                else
                {
                    int k = i;
                    int j = i;

                    while (k < set[0].Length && set[j][k] == Zero()) { 
                        j = i;
                        while (++j < set.Count() && set[j][i] == Zero()) ;
                        if (j < set.Count())
                        {
                            swapListIndex(set, i, j);
                            swapArrayIndex(vec, i, j);
                        } else ++k;
                    }
                    if (k < set[0].Length)
                    {
                        swapArrayIndexInList(set, i, k);
                        p.AddIndexPair(i--, k); // i needs to be explored again in the next step, therefore --.
                    }
                }
            }
        }


        public static LinearCombination<TemplateForFields> UpwardElimination(List<TemplateForFields[]> set, TemplateForFields[] vec)
        {
            LinearCombination<TemplateForFields> lc = new LinearCombination<TemplateForFields>();
            lc.CombinationExists = true;
            if (set.Count() == 0)
            {
                lc.CombinationExists = false;
                return lc;
            }
            lc.Multiplicands = new TemplateForFields[set[0].Length];

            
            for (int i = min(set[0].Length, vec.Length) - 1; i > -1; --i)
            {
                if (vec[i] != Zero() && set[i][i] == Zero()) lc.CombinationExists = false;
                for (int j = i-1; j > -1; --j)
                {
                    vec[j] -= vec[i] * set[j][i];
                    SubtractArray(set[j], MultiplyCopyArray(set[i], set[j][i]));
                }
                lc.Multiplicands[i]=vec[i];
            }
            for (int i = set[0].Length; i < vec.Length; ++i) if (vec[i] != Zero()) lc.CombinationExists = false;
            for (int i = vec.Length; i < set[0].Length; ++i) lc.Multiplicands[i] = Zero();

            return lc;
        }
        private static List<TemplateForFields[]> Transpose(List<TemplateForFields[]> set)
        {
            List<TemplateForFields[]> result = new List<TemplateForFields[]>();
            if (set.Count()==0) return result;
            for (int i = 0; i < set[0].Length; ++i)
            {
                TemplateForFields[] row = new TemplateForFields[set.Count()];
                for (int j = 0; j < set.Count(); ++j) row[j] = set[j][i];
                result.Add(row);
            }
            return result;
        }

        
        public static void DivideArray(TemplateForFields[] a, TemplateForFields b)
        {
            for (int i = 0; i < a.Length; ++i) a[i] = a[i] / b;
        }
        public static void MultiplyArray(TemplateForFields[] a, TemplateForFields b)
        {
            for (int i = 0; i < a.Length; ++i) a[i] = a[i] * b;
        }
    }
}
