﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;


namespace Generator_2._0
{

    /// <summary>
    /// First generator-gui-class
    /// created for gui-mask: direct product panel
    /// </summary>
    public class DirectProductPanel : Panel, IView1
    {
        private Panel panelMain;
        public List<string> attributes;
        private string classname;

        private System.Windows.Forms.Label infotext;
        private System.Windows.Forms.Label choose;
        private System.Windows.Forms.ComboBox possiblS;
        private System.Windows.Forms.Button add;
        public System.Windows.Forms.ListView directProductList;
        private System.Windows.Forms.ColumnHeader semiring;


        IController1 controller;
        public event ViewHandler1<IView1> saveData1;




        // View will set the associated controller, this is how view is linked to the controller.
        public void setController(IController1 cont)
        {
            controller = cont;
        }

        public DirectProductPanel(List<string> userInput, string classname)
        {
            InitializeComponent();
            this.attributes = userInput;
            this.classname = classname;

            // init available SR:
            updateAttributes();
            updateView();
        }

        public void updateAttributes()
        {
            possiblS.Items.Clear();
            //initSelections("config_modules.txt");// no linearcomb garanty
            initSelections("config_main.txt");
            initSelections("config_ASR.txt");
            initSelections("config_field.txt");
            initSelections("config_DP.txt");
            initSelections("config_euclid.txt");
        }

        /// <summary>
        /// update combobox to current available semirings
        /// </summary>
        /// <param name="filename"></param>
        protected void initSelections(string filename)
        {

            string[] configSR = System.IO.File.ReadAllLines(filename);
            foreach (string line in configSR)
            {
                if (line.Length != 0)
                {
                    if (!possiblS.Items.Contains(line.Substring(1, line.Length - 2)))
                    {
                        possiblS.Items.Add(line.Substring(1, line.Length - 2));
                    }

                }

            }
        }

        private void InitializeComponent()
        {

            this.panelMain = new System.Windows.Forms.Panel();
            this.panelMain.SuspendLayout();
            this.SuspendLayout();
            // 

            // 
            // all included windowsforms:
            // 
            this.infotext = new Label();
            this.infotext.AutoSize = true;
            this.infotext.Location = new System.Drawing.Point(10, 14);
            this.infotext.Name = "infotext";
            this.infotext.Size = new System.Drawing.Size(217, 52);
            this.infotext.TabIndex = 0;
            this.infotext.Text = "Please follow this instructions to construct \r\nyour direct product:\r\n";



            this.choose = new Label();
            this.choose.AutoSize = true;
            this.choose.Location = new System.Drawing.Point(13, 101);
            this.choose.Name = "choose";
            this.choose.Size = new System.Drawing.Size(127, 13);
            this.choose.TabIndex = 2;
            this.choose.Text = "1. Choose your semirings:\r\n";
            // 
            // pbossiblS
            // 
            this.possiblS = new ComboBox();
            this.possiblS.FormattingEnabled = true;
            this.possiblS.Location = new System.Drawing.Point(13, 123);
            this.possiblS.Name = "pbossiblS";
            this.possiblS.Size = new System.Drawing.Size(121, 21);
            this.possiblS.TabIndex = 3;

            this.add = new Button();
            this.add.AutoSize = true;
            this.add.Location = new System.Drawing.Point(187, 115);
            this.add.Name = "add";
            this.add.Size = new System.Drawing.Size(40, 25);
            this.add.TabIndex = 6;
            this.add.Text = "Add";
            this.add.Click += new System.EventHandler(this.add_Click_1);


            // 
            // directProductList
            // 
            this.directProductList = new ListView();
            this.semiring = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
            this.directProductList.Anchor = System.Windows.Forms.AnchorStyles.Top;
            this.directProductList.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
            this.semiring});
            this.directProductList.GridLines = true;
            this.directProductList.HideSelection = false;
            this.directProductList.Location = new System.Drawing.Point(13, 150);
            this.directProductList.Name = "directProductList";
            this.directProductList.Scrollable = true;
            this.directProductList.Size = new System.Drawing.Size(180, 140);
            this.directProductList.TabIndex = 14;
            this.directProductList.UseCompatibleStateImageBehavior = false;
            this.directProductList.View = System.Windows.Forms.View.Details;
            this.directProductList.KeyDown += new System.Windows.Forms.KeyEventHandler(this.directProductList_KeyDown);
            // 
            // semiring
            // 
            this.semiring.Text = "Semirings for direct product";
            this.semiring.Width = 175;


            this.panelMain.Controls.Add(infotext);
            this.panelMain.Controls.Add(choose);
            this.panelMain.Controls.Add(possiblS);
            this.panelMain.Controls.Add(add);

            this.panelMain.Controls.Add(directProductList);


            // panelMain

            this.panelMain.BackColor = System.Drawing.SystemColors.GradientInactiveCaption;
            //this.panelMain.Dock = System.Windows.Forms.DockStyle.Fill;
            //this.panelMain.Location = new System.Drawing.Point(12, 6);

            this.panelMain.Location = new System.Drawing.Point(4, 4);
            this.panelMain.Anchor = AnchorStyles.None;
            this.panelMain.Name = "directProduct";
            this.panelMain.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.panelMain.Size = new System.Drawing.Size(235, 310);
            this.panelMain.TabIndex = 0;



            this.Controls.Add(this.panelMain);
            this.Name = "Directproduct";



        }

        /// <summary>
        /// to delete an entry
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void directProductList_KeyDown(object sender, KeyEventArgs e)
        {
            // Remove selected item
            if (e.KeyCode == Keys.Delete)
            {
                List<ListViewItem> remove = new List<ListViewItem>();
                for (int i = 0; i < directProductList.SelectedItems.Count; i++)
                {
                    remove.Add(directProductList.SelectedItems[i]);
                }
                foreach (ListViewItem entry in remove)
                {
                    directProductList.Items.Remove(entry);
                    attributes.Remove(entry.Text);
                }
                try
                {
                    this.saveData1.Invoke(this, new ViewEventUpdateData(classname, "Direct Product", attributes, null));
                }
                catch { }

            }
            //directProductList.Refresh();
        }




        /// <summary>
        /// to add a semiring to the direct product
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void add_Click_1(object sender, EventArgs e)
        {

            if (!String.IsNullOrEmpty(classname))
            {


                if (possiblS.Text == "")
                {
                    MessageBox.Show("Choose a semiring!");
                }

                else
                {
                    string s = "";

                    if (possiblS.Text == "Modulo")
                    {
                        s = (Microsoft.VisualBasic.Interaction.InputBox("Please type in a modulo n for the remainder of the Euclidean division of an integer by n. ", "Input"));
                        try
                        {
                            int mod = Convert.ToInt32(s);
                            ListViewItem itm = new ListViewItem(possiblS.Text + "-" + s);
                            directProductList.Items.Add(itm);
                            attributes.Add(possiblS.Text + "-" + s);
                        }
                        catch
                        {
                            if (s != "") MessageBox.Show("Only digits are allowed!");
                        }
                    }
                    else
                    {
                        ListViewItem itm = new ListViewItem(possiblS.Text);
                        directProductList.Items.Add(itm);
                        attributes.Add(possiblS.Text);

                    }

                    try
                    {
                        this.saveData1.Invoke(this, new ViewEventUpdateData(classname, "Direct Product", attributes, null));
                    }
                    catch { }

                }

            }

            else MessageBox.Show("No classname!", "Info", MessageBoxButtons.OK);
        }


        /// <summary>
        /// gui update of current state
        /// </summary>
        private void updateView()
        {
            directProductList.Items.Clear();

            for (int i = 0; i < attributes.Count; i++)
            {
                ListViewItem itm = new ListViewItem(attributes[i]);
                itm.SubItems.Add("mem" + i);
                directProductList.Items.Add(itm);
            }
        }
    }
}
