using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.CodeDom;

namespace Generator_2._0
{
    /// <summary>
    /// first gui-mask for fieldextensions
    /// 
    /// only inlclude gui-mask for simple field-extension of sqrt(2) and degree 2
    /// 
    /// at the moment no datamodel-saving, because of simple input
    /// </summary>
    class FieldExtPanel : ArbitrarySRPanel, IView1
    {

        protected Panel panelMain;

        //public Dictionary<string, string> methods;


        public int sqrtValue = 0;

        protected Panel panelsqrt;
        protected TextBox textboxsqrt;
        protected Label label1;
        protected Label labelsqrt1;
        protected Label labelsqrt2;
        protected Label labelsqrt3;

        // not in use at the moment
        protected IController1 controller;
        public virtual event ViewHandler1<IView1> saveData1;




        // View will set the associated controller, this is how view is linked to the controller.
        public void setController(IController1 cont)
        {
            controller = cont;
        }



        public FieldExtPanel()
        {
        }
        public FieldExtPanel( RichTextBox sourceBox, string name, TextBox info)
            : base(name, sourceBox, info)
        { 
            InitializeComponent();  
            updateView();
        }

        private void updateView()
        {
            if (sqrtValue!=0) this.textboxsqrt.Text = sqrtValue.ToString();
        }

        protected void InitializeComponent()
        {

            this.panelMain = new System.Windows.Forms.Panel();
            this.panelMain.SuspendLayout();
            this.SuspendLayout();



            this.label1 = new Label();
            this.label1.AutoSize = true;
            this.label1.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(128)))), ((int)(((byte)(255)))), ((int)(((byte)(128)))));
            this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label1.Location = new System.Drawing.Point(11, 10);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(120, 13);
            this.label1.TabIndex = 0;
            this.label1.Text = "1. Fieldextension of Q:";
            // 
            // labelsqrt3
            // 
            this.labelsqrt3 = new Label();
            this.labelsqrt3.AutoSize = true;
            this.labelsqrt3.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(128)))), ((int)(((byte)(255)))), ((int)(((byte)(128)))));
            this.labelsqrt3.Location = new System.Drawing.Point(8, 58);
            this.labelsqrt3.Name = "label2";
            this.labelsqrt3.Size = new System.Drawing.Size(156, 13);
            this.labelsqrt3.TabIndex = 1;
            this.labelsqrt3.Text = "Define irrational number,  sqrt of";

            // 
            //labelsqrt2
            // 
            this.labelsqrt2 = new Label();
            this.labelsqrt2.AutoSize = true;
            this.labelsqrt2.Location = new System.Drawing.Point(7, 29);
            this.labelsqrt2.Name = "label3";
            this.labelsqrt2.Size = new System.Drawing.Size(216, 13);
            this.labelsqrt2.TabIndex = 0;
            this.labelsqrt2.Text = "Complete automatic generation for degree 2.";
            // 
            // textboxsqrt
            // 
            this.textboxsqrt = new TextBox();
            this.textboxsqrt.Location = new System.Drawing.Point(170, 55);
            this.textboxsqrt.Name = "textBox1";
            this.textboxsqrt.Size = new System.Drawing.Size(53, 20);
            this.textboxsqrt.TabIndex = 2;
            this.textboxsqrt.KeyDown +=  new System.Windows.Forms.KeyEventHandler(this.textboxsqrt_KeyDown);
            // 
            // labelsqrt1
            // 
            this.labelsqrt1 = new Label();
            this.labelsqrt1.AutoSize = true;
            this.labelsqrt1.Location = new System.Drawing.Point(8, 74);
            this.labelsqrt1.Name = "label4";
            this.labelsqrt1.Size = new System.Drawing.Size(78, 13);
            this.labelsqrt1.TabIndex = 3;
            this.labelsqrt1.Text = "(positiv integer and press enter)";

            // 
            // panel2
            // 
            this.panelsqrt = new Panel();
            this.panelsqrt.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(128)))), ((int)(((byte)(255)))), ((int)(((byte)(128)))));
            this.panelsqrt.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.panelsqrt.Controls.Add(this.label1);
            this.panelsqrt.Controls.Add(this.labelsqrt1);
            this.panelsqrt.Controls.Add(this.textboxsqrt);
            this.panelsqrt.Controls.Add(this.labelsqrt2);
            this.panelsqrt.Controls.Add(this.labelsqrt3);
            this.panelsqrt.Location = new System.Drawing.Point(5, 6);
            this.panelsqrt.Name = "panel2";
            this.panelsqrt.Size = new System.Drawing.Size(260, 102);
            this.panelsqrt.TabIndex = 3;

  
            this.Controls.Add(this.panelsqrt);

            this.Name = "Field";



        }




        public override bool checkallRequirements()
        {
           
           if (sqrtValue==0) return false;
           return true;
        }


        /*
         * event base for sqrt- fieldextension:
         * 
         */
        private void textboxsqrt_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                // check if digit
                if (!String.IsNullOrEmpty(((TextBox)sender).Text))
                {
                    try
                    {
                        sqrtValue = Convert.ToInt32(((TextBox)sender).Text);

                        // check if irrational
                        double irrational = Math.Sqrt(sqrtValue);
                        if ((irrational % 1) == 0)
                        {
                            MessageBox.Show("You need to define an irrational number!", "Info", MessageBoxButtons.OK);
                            sqrtValue = 0;
                        }


                    }
                    catch (Exception e1)
                    {
                        ((TextBox)sender).Text = null;
                        MessageBox.Show("Only positive integers are allowed!", "Info", MessageBoxButtons.OK);
                    }

                }
            }

        }

    }
}
