using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.CodeDom;

namespace Generator_2._0
{
    /// <summary>, 
    /// this class first was created for field-construction
    /// after research:
    /// 
    /// FieldOfFraction and FieldExtension could be generated automaticly, for
    /// that other panels are used. FieldOfFraction inherits from this one!
    /// 
    /// But fields should be generated using ArbitrarySemirings, because no extra-panel
    /// will have great difference to ArbitrarySemiriring-Panel
    /// </summary>
    class FieldPanel : ArbitrarySRPanel, IView1
    {

        protected Panel panelMain;

        //public Dictionary<string, string> methods;

        protected System.Windows.Forms.Label label3;
        protected System.Windows.Forms.ComboBox comboBox1;

        public System.Windows.Forms.ColumnHeader name;
        protected System.Windows.Forms.Label label5;

        protected System.Windows.Forms.Label label7;
        protected System.Windows.Forms.ComboBox comboBox2;
        protected System.Windows.Forms.ComboBox comboBox3;
        protected System.Windows.Forms.ComboBox comboBox4;
        protected System.Windows.Forms.ComboBox comboBox5;
        protected System.Windows.Forms.Label label6;

        protected System.Windows.Forms.Label label8;

        protected System.Windows.Forms.Label label9;

        protected System.Windows.Forms.ComboBox comboBox6;
        protected System.Windows.Forms.Label label6a;
        protected System.Windows.Forms.Label euclideanrings;

        protected IController1 controller;
        public virtual event ViewHandler1<IView1> saveData1;




        // View will set the associated controller, this is how view is linked to the controller.
        public void setController(IController1 cont)
        {
            controller = cont;
        }



        public FieldPanel()
        {
        }
        public FieldPanel(List<string> attributes, Dictionary<string, string> methods, RichTextBox sourceBox, string  name,TextBox info):base(name,sourceBox,info)
        {

            this.attributes = attributes;
            this.methods = methods;

            InitializeComponent();

    
            updateView();
            //this.comBox1 looking for new types!
            // init available modules:
            updateAttributes();

        }

        /// <summary>
        /// alwasy update to the current available semirings
        /// </summary>
        /// <param name="filename"></param>

        protected override void initSelections(string filename)
        {
            string[] configSR = System.IO.File.ReadAllLines(filename);
            if (filename == "config_field.txt")
            {
                // special semirings are possible with generic polynom-class and fields
                foreach (string line in configSR)
                {
                    if (line.Length != 0)
                    {
                        if (!comboBox1.Items.Contains("Polynom<" + line.Substring(1, line.Length - 2) + ">"))
                        {
                            comboBox1.Items.Add("Polynom<" + line.Substring(1, line.Length - 2) + ">");
                        }
                    }
                }
            }
            else
            {
                foreach (string line in configSR)
                {
                    if (line != "")
                    {
                        if (!comboBox1.Items.Contains(line.Substring(1, line.Length - 2)) && (line != "#uint#") && (!line.Contains("Vector")))
                        {
                            if (!comboBox1.Items.Contains(line.Substring(1, line.Length - 2)))
                            {
                                comboBox1.Items.Add(line.Substring(1, line.Length - 2));
                            }
                        }
                    }
                }
            }
 
        }

        /// <summary>
        /// update to semirings
        /// </summary>
        public override void updateAttributes()
        {
            comboBox1.Items.Clear();
            initSelections("config_modules.txt");
            initSelections("config_field.txt");
            initSelections("config_euclid.txt");
        }

        protected void InitializeComponent()
        {

            this.panelMain = new System.Windows.Forms.Panel();
            this.panelMain.SuspendLayout();
            this.SuspendLayout();




            this.euclideanrings = new Label();
            this.euclideanrings.AutoSize = true;
            this.euclideanrings.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.euclideanrings.Location = new System.Drawing.Point(5, 15);
            this.euclideanrings.Name = "euclid";
            this.euclideanrings.Size = new System.Drawing.Size(111, 13);
            this.euclideanrings.TabIndex = 4;
            this.euclideanrings.Text = "Field of fraction based on euclidean rings";
            // 
            // comboBox1
            // 
            this.comboBox1 = new ComboBox();
            this.comboBox1.FormattingEnabled = true;
            this.comboBox1.Location = new System.Drawing.Point(122, 44);
            this.comboBox1.Name = "comboBox1";
            this.comboBox1.Size = new System.Drawing.Size(110, 21);
            this.comboBox1.TabIndex = 3;
            this.comboBox1.DropDownStyle = ComboBoxStyle.DropDownList;
  

            this.comboBox1.SelectedIndexChanged += new System.EventHandler(this.comboBox1_SelectedIndexChanged);
            comboBox1.MouseWheel += new MouseEventHandler(comboBox1_MouseWheel);
            ToolTip infoModules = new ToolTip();
            infoModules.SetToolTip(comboBox1, "Searching for another Module? First use FreeModules");



            // 
            // label3
            // 
            this.label3 = new Label();
            this.label3.AutoSize = true;
            this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label3.Location = new System.Drawing.Point(5, 47);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(111, 13);
            this.label3.TabIndex = 4;
            this.label3.Text = "Select basetype :";
            // 
            // listView1
            // 
            this.listView1 = new ListView();
            this.name = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
            this.code = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
            this.listView1.Anchor = System.Windows.Forms.AnchorStyles.Top;
            this.listView1.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
            this.name});
            this.listView1.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
            this.code});
            this.listView1.GridLines = true;
            this.listView1.HideSelection = false;
            this.listView1.Location = new System.Drawing.Point(8, 71);
            this.listView1.Name = "listView1";
            this.listView1.Scrollable = true;
            this.listView1.Size = new System.Drawing.Size(224, 93);
            this.listView1.TabIndex = 15;
            this.listView1.UseCompatibleStateImageBehavior = false;
            this.listView1.View = System.Windows.Forms.View.Details;
            this.listView1.KeyDown += new System.Windows.Forms.KeyEventHandler(this.listView1_KeyDown);
            // 
            // names
            //

            this.name.Tag = "";
            this.name.Text = "Selected basetype:";
            this.name.Width = 130;


            this.code.Tag = "";
            this.code.Text = "Name:";
            this.code.Width = 100;
            // 
            // label5
            // 
            this.label5 = new Label();
            this.label5.AutoSize = true;
            this.label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label5.Location = new System.Drawing.Point(8, 171);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(166, 13);
            this.label5.TabIndex = 16;
            this.label5.Text = "Define necessary operators:";
            // 
            // label6
            // 
            this.label6 = new Label();
            this.label6.AutoSize = true;
            this.label6.Location = new System.Drawing.Point(8, 206);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(51, 13);
            this.label6.TabIndex = 17;
            this.label6.Text = "Addition :";


            // 
            // label7
            // 
            this.label7 = new Label();
            this.label7.AutoSize = true;
            this.label7.Location = new System.Drawing.Point(8, 231);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(74, 13);
            this.label7.TabIndex = 19;
            this.label7.Text = "Multiplication :";
            // 
            // comboBox2 
            // 

            ToolTip infoSourceBox = new ToolTip();


            this.comboBox2 = new ComboBox();
            this.comboBox2.Location = new System.Drawing.Point(85, 203);
            this.comboBox2.Name = Constants.ADD;
            this.comboBox2.Size = new System.Drawing.Size(120, 20);
            this.comboBox2.TabIndex = 20;
            this.comboBox2.DropDownStyle = ComboBoxStyle.DropDownList;
            this.comboBox2.Items.AddRange(new object[] {

            "Write code",
            "Componentwise-Member"});


            this.comboBox2.SelectedIndexChanged += new System.EventHandler(this.comboBox_SelectedIndexChanged);
            infoSourceBox.SetToolTip(comboBox2, "If you want to use copy from SourceBox, first press on Help how to use it!");



            // 
            // comboBox3
            // 
            this.comboBox3 = new ComboBox();
            this.comboBox3.Location = new System.Drawing.Point(85, 228);
            this.comboBox3.Name = Constants.MUL;
            this.comboBox3.Size = new System.Drawing.Size(120, 20);
            this.comboBox3.TabIndex = 21;
            this.comboBox3.DropDownStyle = ComboBoxStyle.DropDownList;
            this.comboBox3.Items.AddRange(new object[] {

            "Write code",
            "Componentwise-Member"});


            this.comboBox3.SelectedIndexChanged += new System.EventHandler(this.comboBox_SelectedIndexChanged);


            // 
            // label8
            // 
            this.label8 = new Label();
            this.label8.AutoSize = true;
            this.label8.Location = new System.Drawing.Point(8, 256);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(40, 13);
            this.label8.TabIndex = 22;
            this.label8.Text = "Equal :";
            // 
            // comboBox4
            // 
            this.comboBox4 = new ComboBox();
            this.comboBox4.Location = new System.Drawing.Point(85, 253);
            this.comboBox4.Name = Constants.EQUAL;
            this.comboBox4.Size = new System.Drawing.Size(120, 20);
            this.comboBox4.TabIndex = 23;
            this.comboBox4.DropDownStyle = ComboBoxStyle.DropDownList;
            this.comboBox4.Items.AddRange(new object[] {

            "Write code",
            "Componentwise-Member"});

            this.comboBox4.SelectedIndexChanged += new System.EventHandler(this.comboBox_SelectedIndexChanged);

            // 
            // label9
            // 
            this.label9 = new Label();
            this.label9.AutoSize = true;
            this.label9.Location = new System.Drawing.Point(8, 281);
            this.label9.Name = "label9";
            this.label9.Size = new System.Drawing.Size(61, 13);
            this.label9.TabIndex = 25;
            this.label9.Text = "Subtraction :";
            // 
            // textBox5
            // 
            this.comboBox5 = new ComboBox();
            this.comboBox5.Location = new System.Drawing.Point(85, 280);
            this.comboBox5.Name = Constants.SUB;
            this.comboBox5.Size = new System.Drawing.Size(120, 20);
            this.comboBox5.TabIndex = 26;
            this.comboBox5.DropDownStyle = ComboBoxStyle.DropDownList;
            this.comboBox5.Items.AddRange(new object[] {

            "Write code",
            "Componentwise-Member"});

            this.comboBox5.SelectedIndexChanged += new System.EventHandler(this.comboBox_SelectedIndexChanged);



            this.label6a = new Label();
            this.label6a.AutoSize = true;
            this.label6a.Location = new System.Drawing.Point(8, 308);
            this.label6a.Name = "label6a";
            this.label6a.Size = new System.Drawing.Size(61, 13);
            this.label6a.TabIndex = 25;
            this.label6a.Text = "Division :";
            // 
            // textBox5
            // 
            this.comboBox6 = new ComboBox();
            this.comboBox6.Location = new System.Drawing.Point(85, 309);
            this.comboBox6.Name = Constants.DIV;
            this.comboBox6.Size = new System.Drawing.Size(120, 20);
            this.comboBox6.TabIndex = 26;
            this.comboBox6.DropDownStyle = ComboBoxStyle.DropDownList;
            this.comboBox6.Items.AddRange(new object[] {
           
            "Write code",
            "Componentwise-Member"});

            this.comboBox6.SelectedIndexChanged += new System.EventHandler(this.comboBox_SelectedIndexChanged);





    

            this.panelMain.Controls.Add(comboBox1);
            this.panelMain.Controls.Add(label3);
            this.panelMain.Controls.Add(listView1);
            this.panelMain.Controls.Add(label5);
            this.panelMain.Controls.Add(label6);
            this.panelMain.Controls.Add(comboBox2);

            this.panelMain.Controls.Add(label7);
            this.panelMain.Controls.Add(comboBox2);
            this.panelMain.Controls.Add(comboBox3);
   
            this.panelMain.Controls.Add(label8);
            this.panelMain.Controls.Add(comboBox4);

            this.panelMain.Controls.Add(label9);
            this.panelMain.Controls.Add(comboBox5);
   
            this.panelMain.Controls.Add(label6a);
            this.panelMain.Controls.Add(comboBox6);
            this.panelMain.Controls.Add(euclideanrings);



            // panelMain

            this.panelMain.BackColor = System.Drawing.SystemColors.GradientInactiveCaption;
            this.panelMain.Location = new System.Drawing.Point(4, 6);
            this.panelMain.Name = "Field";
            this.panelMain.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.panelMain.Size = new System.Drawing.Size(260, 340);
            this.panelMain.TabIndex = 0;
            this.panelMain.Anchor = (AnchorStyles.Top | AnchorStyles.Right);


            this.Controls.Add(this.panelMain);


            this.Name = "Field";



        }

        /*
         * event handling:
         */



        /// <summary>
        /// Selection between componentwise generation of corresponding operator/method
        /// 
        /// no constructor, like in the parent class
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected override void comboBox_SelectedIndexChanged(object sender, EventArgs e)
        {

            if (!String.IsNullOrEmpty(classname))
            {
                if (((ComboBox)sender).Text == Constants.SB)
                {
                    // disbale other spezification boxes
                    disableOtherComponents((ComboBox)sender);

                    // enable sourceBox
                    sourcebox.Enabled = true;

                    string box = ((ComboBox)sender).Name;

                    // show if there already exists any code
                    if (methods.Keys.Contains(box))
                    {
                        sourcebox.Clear();
                        sourcebox.AppendText(methods[((ComboBox)sender).Name]);
                    }

                }
                else this.writeMethod(((ComboBox)sender).Text, ((ComboBox)sender).Name, (ComboBox)sender);

            }
            else
            {
                ((ComboBox)sender).SelectedText = "";
                ((ComboBox)sender).SelectedText = "";

                MessageBox.Show("First define a classname!", "Info", MessageBoxButtons.OK);
            }
        }





        /// <summary>
        /// In this method the specific implementation of the binary operator/ method named by the
        /// string box is saved corresponding to the class name of the semiring to generate.
        /// </summary>
        /// <param name="text">implementation information</param>
        /// <param name="box">name of method/operator/constructor</param>
        /// <param name="sender">GUI sender component</param>
        public override void writeMethod(string text, string box, System.Windows.Forms.Control sender)
        {

            if (text != "" && attributes.Count>0)
            {
                //overriding handling:
                if (methods.Keys.Contains(box))
                {
                    Microsoft.VisualBasic.MsgBoxResult response = Microsoft.VisualBasic.Interaction.MsgBox("Do you want to override the existing selection/implementation ? ", Microsoft.VisualBasic.MsgBoxStyle.YesNo, "Override");
                    if (response == Microsoft.VisualBasic.MsgBoxResult.Yes) methods[box] = text;
                }
                else methods.Add(box, text);


                try
                {
                   saveData1.Invoke(this, new ViewEventUpdateData(classname, Constants.FR, attributes, methods));
                }
                catch { }
            }

            else
            {
                if (attributes.Count == 0) MessageBox.Show("First define the basetypes of the semiring-class!", "Info", MessageBoxButtons.OK);
                else MessageBox.Show("Press Help for information how to use the sourceBox!", "Info", MessageBoxButtons.OK);
            }
        }

        /// <summary>
        /// for userinput : code
        /// </summary>
        /// <param name="sender"></param>
        public override void disableOtherComponents(ComboBox sender)
        {
            foreach (Control x in this.panelMain.Controls)
            {
                if (x is ComboBox && x != sender)
                {
                    ((ComboBox)x).Enabled = false;
                }
            }

            this.active = sender; // constructor not captured by this
            setParameterInfo(active);

        }
        //again acitivate all gui-elements
        public override void activateAll()
        {
            foreach (Control x in this.panelMain.Controls)
            {
                if (x is ComboBox)
                {
                    ((ComboBox)x).Enabled = true;
                }
            }

            active = null;
            sourcebox.Enabled = false;

        }



        protected virtual void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
           
            if (classname != "")
            {
                attributes.Add(comboBox1.Text);
                try
                {
                    this.saveData1.Invoke(this, new ViewEventUpdateData(classname, "Field", attributes, methods));
                    this.genMemberNames();
                }
                catch { }
  
            }
            else
            {
                MessageBox.Show("No classname!", "Info", MessageBoxButtons.OK);
            }
        }




        /// <summary>
        /// register the wish to delete an entry
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected virtual void listView1_KeyDown(object sender, KeyEventArgs e)
        {
            // Remove selected item
            if (e.KeyCode == Keys.Delete)
            {
                List<ListViewItem> remove = new List<ListViewItem>();
                for (int i = 0; i < listView1.SelectedItems.Count; i++)
                {
                    remove.Add(listView1.SelectedItems[i]);
                }
                foreach (ListViewItem entry in remove)
                {
                    listView1.Items.Remove(entry);
                    attributes.Remove(entry.Text);
                }
                try
                {
                    this.saveData1.Invoke(this, new ViewEventUpdateData(classname, "Field", attributes, methods));
                }
                catch { }
            }
            this.genMemberNames();
        }


        /// <summary>
        /// this method is specified in the child class
        /// </summary>
        protected virtual void genMemberNames()
        {
            listView1.Items.Clear();

      
                for (int i = 0; i < attributes.Count; i++)
                {
                    ListViewItem itm = new ListViewItem(attributes[i]);
                    itm.SubItems.Add("mem" + i);
                    listView1.Items.Add(itm);
                }

        }

        protected void updateView()
        {
 
            this.genMemberNames();

        }

        /// <summary>
        /// if all 5 methods in gui mask are specified
        /// the user is able to generate the class
        /// </summary>
        /// <returns></returns>
        public override bool checkallRequirements()
        {
            if (attributes.Count() > 0)
            {
                int counter = 5;
                if (methods.Count() < counter) return false;
            }
      
            return true;
        }


      


        

    }
}
