﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Generator_2._0
{
    /// <summary>
    /// GUI-mask for l-momoids
    /// </summary>
    class LMonoidPanel : ArbitrarySRPanel, IView1
    {

        IController1 controller;
        public event ViewHandler1<IView1> saveData1;

        public LMonoidPanel(List<string> attributes, Dictionary<string, string> methods, string classname, RichTextBox sourcebox, TextBox info)
            : base(classname, sourcebox, info)
        {
            this.attributes = attributes;
            this.methods = methods;

            InitializeComponent();

            // update by config files
            updateView();
        }


        // View will set the associated controller, this is how view is linked to the controller.
        public void setController(IController1 cont)
        {
            controller = cont;
        }

        private void InitializeComponent()
        {
            this.panel1 = new System.Windows.Forms.Panel();

            this.linCombi = new System.Windows.Forms.ComboBox();
            this.label12 = new System.Windows.Forms.Label();

            this.div = new System.Windows.Forms.ComboBox();
            this.label11 = new System.Windows.Forms.Label();
            this.label10 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.constructorInput = new System.Windows.Forms.ComboBox();

            this.constructorSelect = new System.Windows.Forms.ComboBox();
            this.listView1 = new System.Windows.Forms.ListView();
            this.selected = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
            this.name = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
            this.comboBox1 = new System.Windows.Forms.ComboBox();
            this.label2 = new System.Windows.Forms.Label();
            this.panel2 = new System.Windows.Forms.Panel();
            this.label8 = new System.Windows.Forms.Label();
            this.comboBox2 = new System.Windows.Forms.ComboBox();
            this.label17 = new System.Windows.Forms.Label();
            this.equal = new System.Windows.Forms.ComboBox();
            this.plus = new System.Windows.Forms.ComboBox();
            this.one = new System.Windows.Forms.ComboBox();
            this.zero = new System.Windows.Forms.ComboBox();
            this.label4 = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this.mul = new System.Windows.Forms.ComboBox();
            this.label7 = new System.Windows.Forms.Label();
            this.label6 = new System.Windows.Forms.Label();
            this.Zerolabel = new System.Windows.Forms.Label();
            this.panel3 = new System.Windows.Forms.Panel();
            this.label1 = new System.Windows.Forms.Label();
            this.label13 = new System.Windows.Forms.Label();
            this.divInfo = new System.Windows.Forms.Label();
            this.panel1.SuspendLayout();
            this.panel2.SuspendLayout();
            this.SuspendLayout();
            // 
            // panel1
            // 
            this.panel1.BackColor = System.Drawing.SystemColors.GradientInactiveCaption;
            this.panel1.Controls.Add(this.label1);
            this.panel1.Controls.Add(this.linCombi);
            this.panel1.Controls.Add(this.label12);
            this.panel1.Controls.Add(this.div);
            this.panel1.Controls.Add(this.label11);
            this.panel1.Controls.Add(this.label10);
            this.panel1.Controls.Add(this.label3);
            this.panel1.Controls.Add(this.constructorInput);
            this.panel1.Controls.Add(this.constructorSelect);
            this.panel1.Controls.Add(this.listView1);
            this.panel1.Controls.Add(this.comboBox1);
            this.panel1.Controls.Add(this.label2);
            this.panel1.Controls.Add(this.panel2);
            this.panel1.Controls.Add(this.panel3);
            this.panel1.Location = new System.Drawing.Point(6, 7);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(525, 471);
            this.panel1.TabIndex = 1;


            // 
            // divInfo
            // 
            this.divInfo.AutoSize = true;
            this.divInfo.Location = new System.Drawing.Point(10, 122);
            this.divInfo.Name = "divInfo";
            this.divInfo.Size = new System.Drawing.Size(139, 91);
            this.divInfo.TabIndex = 0;
            this.divInfo.Text = "*You can define your own \r\nLinearCombination method \r\nwithout  specifying the \r\nD" +
    "ivision /.  \r\nBut if you choose \r\nLargestSoluion you have to \r\ndefine the Divisi" +
    "on too!\r\n";

            // 
            // linCombi
            // 
            this.linCombi.FormattingEnabled = true;
            this.linCombi.Items.AddRange(new object[] {
            "Write code",
            "LargestSolution"});
            this.linCombi.Location = new System.Drawing.Point(293, 291);
            this.linCombi.Name = Constants.LINCOMBI;
            this.linCombi.Size = new System.Drawing.Size(116, 21);
            this.linCombi.TabIndex = 32;
            this.linCombi.SelectedIndexChanged += new System.EventHandler(comboBox_SelectedIndexChanged);
            // 
            // label12
            // 
            this.label12.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(192)))), ((int)(((byte)(192)))), ((int)(((byte)(255)))));
            this.label12.AutoSize = true;
            this.label12.Location = new System.Drawing.Point(290, 274);
            this.label12.Name = "label12";
            this.label12.Size = new System.Drawing.Size(135, 13);
            this.label12.TabIndex = 31;
            this.label12.Text = "LinearCombination(set,vec)*";

            // 
            // div
            // 
            this.div.FormattingEnabled = true;
            this.div.Items.AddRange(new object[] {
            "Write code"});
            this.div.Location = new System.Drawing.Point(309, 241);
            this.div.Name = Constants.DIV;
            this.div.Size = new System.Drawing.Size(104, 21);
            this.div.TabIndex = 29;
            this.div.SelectedIndexChanged += new System.EventHandler(this.comboBox_SelectedIndexChanged);
            // 
            // label11
            // 
            this.label11.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(192)))), ((int)(((byte)(192)))), ((int)(((byte)(255)))));
            this.label11.AutoSize = true;
            this.label11.Font = new System.Drawing.Font("Microsoft Sans Serif", 14.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label11.Location = new System.Drawing.Point(289, 238);
            this.label11.Name = "label11";
            this.label11.Size = new System.Drawing.Size(16, 24);
            this.label11.TabIndex = 28;
            this.label11.Text = "/";
            // 
            // label10
            // 
            this.label10.AutoSize = true;
            this.label10.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label10.Location = new System.Drawing.Point(279, 74);
            this.label10.Name = "label10";
            this.label10.Size = new System.Drawing.Size(90, 13);
            this.label10.TabIndex = 25;
            this.label10.Text = "Optional parts:";
            // 
            // label3
            // 
            this.label3.AutoSize = true;
            this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label3.Location = new System.Drawing.Point(280, 103);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(133, 13);
            this.label3.TabIndex = 8;
            this.label3.Text = "Constructor (Default) :";
            // 
            // constructorInput
            // 
            this.constructorInput.FormattingEnabled = true;
            this.constructorInput.Items.AddRange(new object[] {
            "Componentwise(Default)",
            "Write code"});
            this.constructorInput.Location = new System.Drawing.Point(280, 150);
            this.constructorInput.Name = "constructorInput";
            this.constructorInput.Size = new System.Drawing.Size(147, 21);
            this.constructorInput.TabIndex = 7;


            // 
            // constructorSelect
            // 
            this.constructorSelect.FormattingEnabled = true;
            this.constructorSelect.Items.AddRange(new object[] {
            "Constructor(classname x)",
            "Constructor(selected attributes)",
            "Constructor(string str)"});
            this.constructorSelect.Location = new System.Drawing.Point(280, 122);
            this.constructorSelect.Name = "constructorSelect";
            this.constructorSelect.Size = new System.Drawing.Size(147, 21);
            this.constructorSelect.TabIndex = 5;
            // 
            // listView1
            // 
            this.name = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
            this.selected = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
            this.listView1.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
            this.name});
            this.listView1.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
            this.selected});
            this.listView1.Location = new System.Drawing.Point(24, 98);
            this.listView1.Name = "listView1";
            this.listView1.Size = new System.Drawing.Size(236, 108);
            this.listView1.TabIndex = 3;
            this.listView1.GridLines = true;
            this.listView1.HideSelection = false;
            this.listView1.UseCompatibleStateImageBehavior = false;
            this.listView1.View = System.Windows.Forms.View.Details;
            // 
            // selected
            // 
            this.selected.Text = "Selected basetypes(s):";
            // 
            // name
            // 
            this.name.Text = "Name:";
            this.name.Tag = "";
            this.selected.Text = "Selected basetypes(s):";
            this.name.Width = 120;

            this.selected.Width = 110;

            this.listView1.KeyDown += new System.Windows.Forms.KeyEventHandler(this.listView1_KeyDown);

            this.listView1.ColumnWidthChanging += new System.Windows.Forms.ColumnWidthChangingEventHandler(this.listView1_ColumnWidthChanging);



            // 
            // comboBox1
            // 
            this.comboBox1.BackColor = System.Drawing.Color.LightCoral;
            this.comboBox1.ForeColor = System.Drawing.SystemColors.Info;
            this.comboBox1.FormattingEnabled = true;
            this.comboBox1.Items.AddRange(new object[] {
            "int",
            "uint",
            "double",
            "Vector-double",
            "Vector-int"});
            this.comboBox1.Location = new System.Drawing.Point(136, 71);
            this.comboBox1.Name = "comboBox1";
            this.comboBox1.Size = new System.Drawing.Size(121, 21);
            this.comboBox1.TabIndex = 2;
            this.comboBox1.SelectedIndexChanged += new System.EventHandler(this.comboBox1_SelectedIndexChanged);
            comboBox1.MouseWheel += new MouseEventHandler(comboBox1_MouseWheel);
            // 
            // label2
            // 
            this.label2.AutoSize = true;
            this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label2.Location = new System.Drawing.Point(21, 74);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(113, 13);
            this.label2.TabIndex = 1;
            this.label2.Text = "Select basetypes(s):";


            // 
            // label8
            // 
            this.label8.AutoSize = true;
            this.label8.Font = new System.Drawing.Font("Microsoft Sans Serif", 14.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label8.Location = new System.Drawing.Point(3, 98);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(34, 24);
            this.label8.TabIndex = 25;
            this.label8.Text = "==";
            // 
            // comboBox2
            // 
            this.comboBox2.FormattingEnabled = true;
            this.comboBox2.Items.AddRange(new object[] {
            "Write code"});
            this.comboBox2.Location = new System.Drawing.Point(39, 129);
            this.comboBox2.Name = Constants.GREATER;
            this.comboBox2.Size = new System.Drawing.Size(107, 21);
            this.comboBox2.TabIndex = 36;
            this.comboBox2.SelectedIndexChanged += new System.EventHandler(this.comboBox_SelectedIndexChanged);
            // 
            // label17
            // 
            this.label17.AutoSize = true;
            this.label17.Font = new System.Drawing.Font("Microsoft Sans Serif", 14.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label17.Location = new System.Drawing.Point(8, 127);
            this.label17.Name = "label17";
            this.label17.Size = new System.Drawing.Size(22, 24);
            this.label17.TabIndex = 35;
            this.label17.Text = ">";

            // 
            // equal
            // 
            this.equal.FormattingEnabled = true;
            this.equal.Items.AddRange(new object[] {
            "Write code"});
            this.equal.Location = new System.Drawing.Point(39, 100);
            this.equal.Name = Constants.EQUAL;
            this.equal.Size = new System.Drawing.Size(107, 21);
            this.equal.TabIndex = 23;
            this.equal.SelectedIndexChanged += new System.EventHandler(this.comboBox_SelectedIndexChanged);
            // 
            // plus
            // 
            this.plus.FormattingEnabled = true;
            this.plus.Items.AddRange(new object[] {
            "Write code"});
            this.plus.Location = new System.Drawing.Point(39, 42);
            this.plus.Name = Constants.ADD;
            this.plus.Size = new System.Drawing.Size(107, 21);
            this.plus.TabIndex = 10;
            this.plus.SelectedIndexChanged += new System.EventHandler(this.comboBox_SelectedIndexChanged);
            // 
            // one
            // 
            this.one.FormattingEnabled = true;
            this.one.Items.AddRange(new object[] {
            "Write code"});
            this.one.Location = new System.Drawing.Point(39, 189);
            this.one.Name = Constants.O;
            this.one.Size = new System.Drawing.Size(107, 21);
            this.one.TabIndex = 21;
            this.one.SelectedIndexChanged += new System.EventHandler(this.comboBox_SelectedIndexChanged);

            // 
            // zero
            // 
            this.zero.FormattingEnabled = true;
            this.zero.Items.AddRange(new object[] {
            "Write code"});
            this.zero.Location = new System.Drawing.Point(39, 161);
            this.zero.Name = Constants.Z;
            this.zero.Size = new System.Drawing.Size(107, 21);
            this.zero.TabIndex = 18;
            this.zero.SelectedIndexChanged += new System.EventHandler(this.comboBox_SelectedIndexChanged);
            // 
            // label4
            // 
            this.label4.AutoSize = true;
            this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label4.Location = new System.Drawing.Point(-1, 2);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(102, 13);
            this.label4.TabIndex = 9;
            this.label4.Text = "Necessary parts:";
            // 
            // label5
            // 
            this.label5.AutoSize = true;
            this.label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 14.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label5.Location = new System.Drawing.Point(6, 42);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(22, 24);
            this.label5.TabIndex = 13;
            this.label5.Text = "+";
            // 
            // mul
            // 
            this.mul.FormattingEnabled = true;
            this.mul.Items.AddRange(new object[] {
            "Write code"});
            this.mul.Location = new System.Drawing.Point(39, 71);
            this.mul.Name = Constants.MUL;
            this.mul.Size = new System.Drawing.Size(107, 21);
            this.mul.TabIndex = 12;
            this.mul.SelectedIndexChanged += new System.EventHandler(this.comboBox_SelectedIndexChanged);


            // 
            // label7
            // 
            this.label7.AutoSize = true;
            this.label7.Location = new System.Drawing.Point(6, 192);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(33, 13);
            this.label7.TabIndex = 20;
            this.label7.Text = "One()";
            // 
            // label6
            // 
            this.label6.AutoSize = true;
            this.label6.Font = new System.Drawing.Font("DejaVu Serif", 14.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label6.Location = new System.Drawing.Point(8, 74);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(20, 22);
            this.label6.TabIndex = 14;
            this.label6.Text = "*";
            // 
            // Zerolabel
            // 
            this.Zerolabel.AutoSize = true;
            this.Zerolabel.Location = new System.Drawing.Point(4, 164);
            this.Zerolabel.Name = "Zerolabel";
            this.Zerolabel.Size = new System.Drawing.Size(35, 13);
            this.Zerolabel.TabIndex = 17;
            this.Zerolabel.Text = "Zero()";

            // 
            // panel3
            // 
            this.panel3.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(192)))), ((int)(((byte)(192)))), ((int)(((byte)(255)))));
            this.panel3.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.panel3.Controls.Add(this.divInfo);
            this.panel3.Location = new System.Drawing.Point(280, 222);
            this.panel3.Name = "panel3";
            this.panel3.Size = new System.Drawing.Size(159, 227);
            this.panel3.TabIndex = 34;
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Font = new System.Drawing.Font("Consolas", 20.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label1.Location = new System.Drawing.Point(198, 18);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(135, 32);
            this.label1.TabIndex = 35;
            this.label1.Text = "l-Monoid";
            // 
            // label13
            // 
            this.label13.AutoSize = true;
            this.label13.Location = new System.Drawing.Point(3, 22);
            this.label13.Name = "label13";
            this.label13.Size = new System.Drawing.Size(133, 13);
            this.label13.TabIndex = 38;
            this.label13.Text = "(Parameter a, Parameter b)";

            // 
            // panel2
            // 
            this.panel2.BackColor = System.Drawing.Color.LightCoral;
            this.panel2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.panel2.Controls.Add(this.label13);
            this.panel2.Controls.Add(this.label8);
            this.panel2.Controls.Add(this.comboBox2);
            this.panel2.Controls.Add(this.label17);
            this.panel2.Controls.Add(this.equal);
            this.panel2.Controls.Add(this.plus);
            this.panel2.Controls.Add(this.label4);
            this.panel2.Controls.Add(this.label5);
            this.panel2.Controls.Add(this.one);
            this.panel2.Controls.Add(this.mul);
            this.panel2.Controls.Add(this.label6);
            this.panel2.Controls.Add(this.zero);
            this.panel2.Controls.Add(this.Zerolabel);
            this.panel2.Controls.Add(this.label7);
            this.panel2.Location = new System.Drawing.Point(24, 222);
            this.panel2.Name = "panel2";
            this.panel2.Size = new System.Drawing.Size(236, 227);
            this.panel2.TabIndex = 23;
            // 
            // Form2
            // 

            this.ClientSize = new System.Drawing.Size(543, 484);
            this.Controls.Add(this.panel1);
            this.Name = "Form2";
            this.Text = "Form2";
            this.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.panel1.ResumeLayout(false);
            this.panel1.PerformLayout();
            this.panel2.ResumeLayout(false);
            this.panel2.PerformLayout();
            this.ResumeLayout(false);

            // init comboBox
            updateAttributes();
        }


        /// <summary>
        /// to update the basetype selection
        /// </summary>
        public override void updateAttributes()
        {
            this.comboBox1.Items.Clear();
            initSelections("config_modules.txt");
            initSelections("config_ASR.txt");
            initSelections("config_field.txt");
            initSelections("config_DP.txt");
            initSelections("config_euclid.txt");
            initSelections("config_main.txt");
        }
        protected override void initSelections(string filename)
        {

            string[] configSR = System.IO.File.ReadAllLines(filename);
            foreach (string line in configSR)
            {
                if (line.Length != 0)
                {
                    if (!this.comboBox1.Items.Contains(line.Substring(1, line.Length - 2)))
                    {
                        this.comboBox1.Items.Add(line.Substring(1, line.Length - 2));
                        //string-constructor generation for FiniteLattice [] not tested anyway
                       if( !line.Contains("FiniteLattice"))this.comboBox1.Items.Add(line.Substring(1, line.Length - 2) + "[]");
                    }

                }

            }
        }

        /*event handling:
         */

        /// <summary>
        /// In this method the specific implementation of the binary operator/ method named by the
        /// string box is saved corresponding to the class name of the semiring to generate.
        /// </summary>
        /// <param name="text">implementation information</param>
        /// <param name="box">name of method/operator/constructor</param>
        /// <param name="sender">GUI sender component</param>
        public override void writeMethod(string text, string box, System.Windows.Forms.Control sender)
        {

            if (text != "" && attributes.Count > 0)
            {
                //Dictionary<string, string>
                if (methods.Keys.Contains(box))
                {
                    Microsoft.VisualBasic.MsgBoxResult response = Microsoft.VisualBasic.Interaction.MsgBox("Do you want to override the existing selection/implementation ? ", Microsoft.VisualBasic.MsgBoxStyle.YesNo, "Override");
                    if (response == Microsoft.VisualBasic.MsgBoxResult.Yes) methods[box] = text;
                }
                else methods.Add(box, text);


                try
                {
                    saveData1.Invoke(this, new ViewEventUpdateData(classname, "lmonoid", attributes, methods));
                }
                catch { }
            }

            else
            {
                if (attributes.Count == 0) MessageBox.Show("First define the basetypes of the semiring-class!", "Info", MessageBoxButtons.OK);
                else MessageBox.Show("Press Help for information how to use the sourceBox!", "Info", MessageBoxButtons.OK);
            }
        }

        public override void disableOtherComponents(ComboBox sender)
        {
            foreach (Control x in this.panel1.Controls)
            {
                if (x is ComboBox && x != sender)
                {
                    ((ComboBox)x).Enabled = false;
                }
            }
            foreach (Control x in this.panel2.Controls)
            {
                if (x is ComboBox && x != sender)
                {
                    ((ComboBox)x).Enabled = false;
                }
            }

            foreach (Control x in this.panel3.Controls)
            {
                if (x is ComboBox && x != sender)
                {
                    ((ComboBox)x).Enabled = false;
                }
            }

            this.active = sender; // constructor not captured by this

            if (sender.Name == "constructorInput")
            {
                if ((constructorSelect.Text == "Constructor(classname x)")) active.Name = Constants.C1;
                if (constructorSelect.Text == "Constructor(selected attributes)") active.Name = Constants.C2;
                if (constructorSelect.Text == "Constructor(string str)") active.Name = Constants.C3;
            }
            setParameterInfo(active);
        }

        public override void activateAll()
        {
            foreach (Control x in this.Controls)
            {
                if (x is ComboBox)
                {
                    ((ComboBox)x).Enabled = true;
                }
            }
            foreach (Control x in panel2.Controls)
            {
                if (x is ComboBox)
                {
                    ((ComboBox)x).Enabled = true;
                }
            }
            foreach (Control x in panel1.Controls)
            {
                if (x is ComboBox)
                {
                    ((ComboBox)x).Enabled = true;
                }
            }

            active = null;
            constructorInput.Name = "constructorInput";
            sourcebox.Enabled = false;

        }





        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (classname != "")
            {
                attributes.Add(comboBox1.Text);
                try
                {
                    saveData1.Invoke(this, new ViewEventUpdateData(classname, Constants.LM, attributes, methods));

                }
                catch { }


            }
            else MessageBox.Show("No classname!", "Info", MessageBoxButtons.OK);

            genMemberNames();
        }

        private void listView1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Delete)
            {
                List<ListViewItem> remove = new List<ListViewItem>();
                for (int i = 0; i < listView1.SelectedItems.Count; i++)
                {
                    remove.Add(listView1.SelectedItems[i]);
                }
                foreach (ListViewItem entry in remove)
                {
                    listView1.Items.Remove(entry);
                    attributes.Remove(entry.Text);
                }
                try
                {
                    saveData1.Invoke(this, new ViewEventUpdateData(classname, "lmonoid", attributes, methods));
                }
                catch { }
            }
            genMemberNames();
        }

        private void listView1_ColumnWidthChanging(object sender, ColumnWidthChangingEventArgs e)
        {
            e.Cancel = true;
            e.NewWidth = ((ListView)sender).Columns[e.ColumnIndex].Width;
        }




        public override bool checkallRequirements()
        {
            if (!methods.Keys.Contains(Constants.ADD)) return false;
            if (!methods.Keys.Contains(Constants.MUL)) return false;
            if (!methods.Keys.Contains(Constants.Z)) return false;
            if (!methods.Keys.Contains(Constants.O)) return false;
            if (!methods.Keys.Contains(Constants.GREATER)) return false;
            if (!methods.Keys.Contains(Constants.LINCOMBI)) return false;
            if (!methods.Keys.Contains(Constants.C1)) methods.Add(Constants.C1, Constants.CM);
            if (!methods.Keys.Contains(Constants.C2)) methods.Add(Constants.C2, Constants.CM);
            if (!methods.Keys.Contains(Constants.C3)) methods.Add(Constants.C3, Constants.CM);

            if ((methods[Constants.LINCOMBI] == "LargestSolution") && !methods.Keys.Contains(Constants.DIV))
                {
                    MessageBox.Show("You must define the / operation!");
                    return false;
                }

            return true;
        }



        private void updateView()
        {
            genMemberNames();

            foreach (KeyValuePair<string, string> entry in methods)
            {
                switch (entry.Key)
                {
                    case Constants.LINCOMBI:
                        if (entry.Key == "Write code") linCombi.SelectedText = "Write code";
                        else linCombi.SelectedText = "LargestSolution";
                        break;
                    case Constants.Z:
                        if (entry.Value.Contains(Constants.CM)) zero.SelectedText = entry.Value;
                        else zero.SelectedText = "Write code";
                        break;
                    case Constants.O:
                        if (entry.Value.Contains(Constants.CM)) one.SelectedText = entry.Value;
                        else one.SelectedText = "Write code";
                        break;
                    case Constants.ADD:
                        if (entry.Value.Contains(Constants.CM)) plus.SelectedText = entry.Value;
                        else plus.SelectedText = "Write code";
                        break;
                    case Constants.MUL:
                        if (entry.Value.Contains(Constants.CM)) mul.SelectedText = entry.Value;
                        else mul.SelectedText = "Write code";
                        break;
                    case Constants.DIV:
                        div.SelectedText = "Write code";
                        break;
                    case Constants.EQUAL:
                        if (entry.Value.Contains("Componentwise")) equal.SelectedText = entry.Value;
                        else equal.SelectedText = "Write code";
                        break;
                    case Constants.GREATER:
                        if (entry.Value.Contains(Constants.CM)) comboBox2.SelectedText = entry.Value;
                        else comboBox2.SelectedText = "Write code";
                        break;
                }
            }
        }





        private System.Windows.Forms.Panel panel1;
        private System.Windows.Forms.ComboBox comboBox2;
        private System.Windows.Forms.Label label17;

        private System.Windows.Forms.ComboBox linCombi;
        private System.Windows.Forms.Label label12;
        private System.Windows.Forms.ComboBox div;
        private System.Windows.Forms.Label label11;
        private System.Windows.Forms.Label label3;


        private System.Windows.Forms.ColumnHeader selected;
        private System.Windows.Forms.ComboBox comboBox1;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.Panel panel2;
        private System.Windows.Forms.Label label8;

        private System.Windows.Forms.ComboBox equal;
        private System.Windows.Forms.ComboBox plus;
        private System.Windows.Forms.ComboBox one;
        private System.Windows.Forms.ComboBox zero;
        private System.Windows.Forms.Label label4;
        private System.Windows.Forms.Label label5;
        private System.Windows.Forms.ComboBox mul;

        private System.Windows.Forms.Label label7;
        private System.Windows.Forms.Label label6;
        private System.Windows.Forms.Label Zerolabel;
        private System.Windows.Forms.Label label10;
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.Panel panel3;
        private System.Windows.Forms.Label label13;
        private System.Windows.Forms.Label divInfo;
    }
}
