﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;

namespace Generator_2._0
{
    /// <summary>
    /// this class includes the current naive gauss-implementation in a "template"
    /// TODO:should be in future done by numeric lib, but for that an adaption of the semiring-classes is needed
    /// </summary>

    public static class PredifCode
    {





        // predifined findLinearCombination for LMonoids:



        // predifined findLinearCombination for fields:



        public static string DivideArray(string classname)
        {
            return "          for (int i = 0; i < a.Length; ++i) a[i] = a[i] / b;\n";
        }


        public static string MultiplyArray(string classname)
        {
            return "          for (int i = 0; i < a.Length; ++i) a[i] = a[i] * b;\n";
        }


        public static string MultiplyCopyArray(string classname)
        {
            return "          " + classname + "[] result = CopyArray(a);\n" +
                   "          MultiplyArray(result, b);\n" +
                   "          return result;\n";
        }


        public static string SubtractArray(string classname)
        {
            return "           for (int i = 0; i < a.Length; ++i) a[i] = a[i] - b[i];\n";
        }


        public static string AddArray(string classname)
        {
            return "           for (int i = 0; i < a.Length; ++i) a[i] = a[i] + b[i];\n";
        }

        public static string SubtractArray1(string classname)
        {
            return "           for (int i = 0; i < a.Length; ++i) a[i] = a[i] - b;\n";
        }

        public static string AddArray1(string classname)
        {
            return "           for (int i = 0; i < a.Length; ++i) a[i] = a[i] + b;\n";
        }

        public static string Transpose(string classname)
        {
            return "        return Transpose<" + classname + ">(a);\n";
        }


        public static string CopyArray(string classname, List<string> member)
        {
            string mem = "";
            for (int i = 0; i < member.Count; i++)
            {
                if (i != member.Count - 1) mem += "a[i].mem" + i + ",";
                else mem += "a[i].mem" + i;

            }
            return "        " + classname + "[] result = new " + classname + "[a.Length];\n" +
                   "        for (int i = 0; i < a.Length; ++i) result[i] = new " + classname + "(" + mem + ");\n" +
                   "        return result;";
        }



        public static string DeepArrayCopy(string classname, List<string> member)
        {
            string mem = "";
            for (int i = 0; i < member.Count; i++)
            {
                if (i != member.Count - 1) mem += "a[i].mem" + i + ",";
                else mem += "a[i].mem" + i;

            }
            return "        " + classname + "[] result = new " + classname + "[a.Length];\n" +
                   "        for (int i = 0; i < a.Length; ++i) result[i] = new " + classname + "(" + mem + ");\n" +
                   "        return result;";
        }


        public static string DeepRowListCopy(string classname, List<string> member)
        {

            string mem = "";
            for (int i = 0; i < member.Count; i++)
            {
                if (i != member.Count - 1) mem += "set[i][j].mem" + i + ",";
                else mem += "set[i][j].mem" + i;

            }
            return "        List<" + classname + "[]> result = new List<" + classname + "[]>();\n" +
                   "        for (int i = 0; i < set.Count; ++i)\n" +
                   "        {\n" +
                   "        " + classname + "[] row = new " + classname + "[set[i].Length];\n" +
                   "        for (int j = 0; j < set[i].Length; ++j)\n" +
                   "        {\n" +
                   "        row[j] = new " + classname + "(" + mem + ");\n" +
                   "        }\n" +
                   "        result.Add(row);\n" +
                   "        }\n" +
                   "        return result;\n";
        }







        public static string DownwardElimination(string classname)
        {
            return "       if (set.Count == 0) return;\n" +
                    "       for (int i = 0; (i< set[0].Length) && (i<set.Count); ++i)\n" +
                    "       {\n" +
                    "       if (set[i][i] != Zero())\n" +
                    "       {\n" +
                    "           vec[i] /= set[i][i];\n" +
                    "           DivideArray(set[i], set[i][i]);\n" +
                    "           for (int j = i+1; j < set.Count; ++j)\n" +
                    "           {\n" +
                    "                vec[j] -= vec[i] * set[j][i];\n" +
                    "                SubtractArray(set[j], MultiplyCopyArray(set[i], set[j][i]));\n" +
                    "           }\n" +
                    "       }\n" +
                    "       else\n" +
                    "       {\n" +
                    "           int k = i;\n" +
                    "           int j = i;\n" +
                    "           for (j = i; (j < set.Count) && (set[j][k] == Zero()); ++j) \n" +
                    "           {\n" +
                    "               for (k = i; (k < set[0].Length) && (set[j][k] == Zero()); ++k) ;\n" +
                    "                if (k == set[0].Length) k = i;\n" +
                    "                if (set[j][k] != Zero()) break;\n" +
                    "           }\n" +
                    "       if ((j < set.Count)&&(set[j][k] != Zero()))\n" +
                    "       {\n" +
                    "        swapListIndex(set, i, j);\n" +
                    "        swapArrayIndex(vec, i, j);\n" +
                    "        swapArrayIndexInList(set, i, k);\n" +
                    "        p.AddIndexPair(i--, k);\n" +
                    "       }\n" +

                "       }\n" +
            "       }\n";
        }

        public static string UpwardElimination(string classname)
        {
            return "        LinearCombination<" + classname + "> lc = new LinearCombination<" + classname + ">();\n" +
                   "        lc.CombinationExists = true;\n" +
                   "        if (set.Count == 0)\n" +
                   "        {\n" +
                   "        lc.CombinationExists = false;\n" +
                   "        return lc;\n" +
                   "        }\n" +
                   "        lc.Multiplicands = new " + classname + "[set[0].Length];\n" +


                   "        for (int i = min(set[0].Length, vec.Length) - 1; i > -1; --i)\n" +
                   "        {\n" +
                   "        if (vec[i] != Zero() && set[i][i] == Zero()) lc.CombinationExists = false;\n" +
                   "        for (int j = i-1; j > -1; --j)\n" +
                   "        {\n" +
                   "        vec[j] -= vec[i] * set[j][i];\n" +
                   "        SubtractArray(set[j], MultiplyCopyArray(set[i], set[j][i]));\n" +
                   "        }\n" +
                   "        lc.Multiplicands[i]=vec[i];\n" +
                   "        }\n" +
                   "        for (int i = set[0].Length; i < vec.Length; ++i) if (vec[i] != Zero()) lc.CombinationExists = false;\n" +
                   "        for (int i = vec.Length; i < set[0].Length; ++i) lc.Multiplicands[i] = Zero();\n" +

                   "        return lc;\n";

        }




        public static string LinearCombination(string classname)
        {
            return "        List<" + classname + "[]> setT = Transpose(DeepRowListCopy(set));\n" +
                   "        Permutation p = new Permutation();\n" +
                   "        " + classname + "[] vecCopy = DeepArrayCopy(vec);\n" +

                   "        DownwardElimination(setT, vecCopy, p);\n" +

                   "        LinearCombination<" + classname + "> lc = UpwardElimination(setT, vecCopy);\n" +
                   "        p.ApplyTo<" + classname + ">(lc.Multiplicands);\n" +

                   "        return lc;\n";
        }







    }
}