﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.Windows.Forms;
using Microsoft.Build.Execution;
using Microsoft.Build.Evaluation;
using Microsoft.Build.BuildEngine;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization;
using System.IO;
using System.Threading;
namespace Generator_2._0
{
    static class Program
    {
        /// <summary>
        /// Main entry point for program
        /// </summary>
        [STAThread]
        static void Main()
        {
            Thread.CurrentThread.CurrentCulture =System.Globalization.CultureInfo.InvariantCulture;
            // three controller models (different interaction panels) 
            // datamodel for arbitrary semirings
            DataModelExd2 model = new DataModelExd2();
            // directproduct
            DataModel dp = new DataModel();
            // fieldextension
            DataModelExd fe = new DataModelExd();
            // lmonoid
            DataModelExd lmono = new DataModelExd();
            // main controller for main GUI
            // containing all models
            Dictionary<string, DataModel> models = new Dictionary<string, DataModel>();
            models.Add(Constants.ASR, model);
            models.Add(Constants.DP, dp);
            models.Add(Constants.FR, fe);
            models.Add(Constants.LM, lmono);

            /*
             *deserialize test, always open last session:
             */
            IFormatter formatter = new BinaryFormatter();

            try
            {
                Stream fromstream = new FileStream("autosave" + ".bin",
                              FileMode.Open,
                              FileAccess.Read,
                              FileShare.Read);
                try
                {
                    models = (Dictionary<string, DataModel>)formatter.Deserialize(fromstream);
                }
                catch { }

                fromstream.Close();
            }
            catch { }

            // two controller for different Event-types corresponding to the different semiring generator option panels:
            // init model: arbitrarypanels
            Controller1 cn1 = new Controller1(model);
            Controller2 cn2 = new Controller2(model);
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Form1 view = new Form1(cn1, cn2);
     
            
            // this constructor is calling setController from the main view
            IController cnt = new Controller(models,view);
            // get the model observer update
            cn1.setController(cnt);
            cn2.setController(cnt);
            cn1.setModel((DataModelExd2)((Controller)cnt).getModel(Constants.ASR));
            cn2.setModel((DataModelExd2)((Controller)cnt).getModel(Constants.ASR));
            Application.Run(view);
        }
    }


    /// <summary>
    /// to rebuild the AlgoB Program
    /// </summary>
    public class Compiler
    {

        public static void Build(string msbuildFileName)
        {
            ProjectCollection pc = new ProjectCollection();

            Dictionary<string, string> GlobalProperty = new Dictionary<string, string>();

            GlobalProperty.Add("Configuration", "Debug");

            GlobalProperty.Add("Platform", "Any CPU");

            BuildRequestData BuidlRequest = new BuildRequestData(msbuildFileName, GlobalProperty, null, new string[] { "Build" }, null);

            BuildResult buildResult = BuildManager.DefaultBuildManager.Build(new BuildParameters(pc), BuidlRequest);
            //manager.ResetCaches();
            //manager.Dispose();
        }
    }
}
